#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "shoot2zero4xi.py">
#<abstract4xi abstract = "shoots to zero"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'shoot2zero4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "

from sphere4xi import init_sphere2zero4xi 
from sphere4xi import set_sphere2zero4xi 
from sphere4xi import get_sphere2zero4xi 

from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "

      
#"
#"/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "shoot2zero4xi" usage = "creating spheres">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def shoot2zero4xi(queue2zero = None, consumer_channel2zero = None, publisher_channel2zero = None,
             start2distance = None, interval2distance = None, max2layer = None, marginal2layer = None, max2count = None,
             marginal2count = None, sign2x = None, sign2y = None, sign2z = None, max2iterate = None,
             start2plusa = None, max2plusa = None, min2plusa = None, start2minusa = None, max2minusa = None, min2minusa = None,
             start2pluse = None, max2pluse = None, min2pluse = None, start2minuse = None, max2minuse = None, min2minuse = None,
             increase2distance = None, change2a = None, change2e = None, increase2a = None, increase2e = None ):
    '''
    shoots according to required parameters
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    print("\n (STEP 1A0/33) OF SHOOT2ZERO4XI - STARTED TIME: ", time2start) 
    
    
    print("\n (STEP 1A2/33) OF SHOOT2ZERO4XI -  QUEUE2ZERO: ", queue2zero)      
    # 
    
    print("\n (STEP 1A3/33) OF SHOOT2ZERO4XI -  CONSUMER_CHANNEL2ZERO: ", consumer_channel2zero)
    # 
          
    print("\n (STEP 1A4/33) OF SHOOT2ZERO4XI -  PUBLISHER_CHANNEL2ZERO: ", publisher_channel2zero)          
    # 
            
    
    print("\n (STEP 1A5/33) OF SHOOT2ZERO4XI -  START TO DISTANCE: ", start2distance) 
    print("\n (STEP 1A6/33) OF SHOOT2ZERO4XI -  INTERVAL TO DISTANCE: ", interval2distance)
    print("\n (STEP 1A7/33) OF SHOOT2ZERO4XI -  MAX TO LAYER: ", max2layer)    
    print("\n (STEP 1A8/33) OF SHOOT2ZERO4XI -  MARGINAL TO LAYER: ", marginal2layer)
    print("\n (STEP 1A9/33) OF SHOOT2ZERO4XI -  SIGN TO X: ", sign2x)       
    print("\n (STEP 1A10/33) OF SHOOT2ZERO4XI -  SIGN TO Y: ", sign2y)
    print("\n (STEP 1A11/33) OF SHOOT2ZERO4XI -  SIGN TO Z: ", sign2z)    
    print("\n (STEP 1A12/33) OF SHOOT2ZERO4XI -  START TO PLUS AZIMUTH: ", start2plusa)
    print("\n (STEP 1A13/33) OF SHOOT2ZERO4XI -  MAX TO PLUS AZIMUTH: ", max2plusa)       
    print("\n (STEP 1A14/33) OF SHOOT2ZERO4XI -  MIN TO PLUS AZIMUTH: ", min2plusa)
    print("\n (STEP 1A15/33) OF SHOOT2ZERO4XI -  START TO MINUS AZIMUTH: ", start2minusa)
    print("\n (STEP 1A16/33) OF SHOOT2ZERO4XI -  MAX TO MINUS AZIMUTH: ", max2minusa)
    print("\n (STEP 1A17/33) OF SHOOT2ZERO4XI -  MIN TO MINUS AZIMUTH: ", min2minusa)    
    print("\n (STEP 1A18/33) OF SHOOT2ZERO4XI -  START TO PLUS ELEVATION: ", start2pluse)
    print("\n (STEP 1A19/33) OF SHOOT2ZERO4XI -  MAX TO PLUS ELEVATION: ", max2pluse)
    print("\n (STEP 1A20/33) OF SHOOT2ZERO4XI -  MIN TO PLUS ELEVATION: ", min2pluse)
    print("\n (STEP 1A21/33) OF SHOOT2ZERO4XI -  START TO MINUS ELEVATION: ", start2minuse) 
    print("\n (STEP 1A22/33) OF SHOOT2ZERO4XI -  MAX TO MINUS ELEVATION: ", max2minuse)
    print("\n (STEP 1A23/33) OF SHOOT2ZERO4XI -  MIN TO MINUS ELEVATION: ", min2minuse)
    print("\n (STEP 1A24/33) OF SHOOT2ZERO4XI -  INCREASE TO DISTANCE: ", increase2distance)
    print("\n (STEP 1A25/33) OF SHOOT2ZERO4XI -  CHANGE TO AZIMUTH: ", change2a) 
    print("\n (STEP 1A26/33) OF SHOOT2ZERO4XI -  CHANGE TO ELEVATION: ", change2e)           
    print("\n (STEP 1A27/33) OF SHOOT2ZERO4XI -  INCREASE TO AZIMUTH: ", increase2a)  
    print("\n (STEP 1A28/33) OF SHOOT2ZERO4XI -  INCREASE TO ELEVATION: ", increase2e)  
                                                      
    # =================================================================================================                   
    # INITIALIZATIONS
    # =================================================================================================         
    print("\n (STEP 2A/33) OF SHOOT2ZERO4XI - INITIALIZING SPHERE4XI ") 
        
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # SPHERE2XI USING FUNCTION
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
    init_sphere2zero4xi(message2sphere = "shoot4core", message2shot = 'shoot4skeleton')
    print("\n (STEP 2C/33) OF SHOOT2ZERO4XI - PEFORMED INIT_SPHERE2ZERO4XI")     

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # DISTANCE
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                        
    if start2distance is None:
        start2distance = 100
    start2distance4xi = int(start2distance)
    print("\n (STEP 3A/33) OF SHOOT2ZERO4XI - START2DISTANCE4XI: ", start2distance4xi)
    # 
    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # INTERVAL
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                     
    if interval2distance is None:
        interval2distance = 100
    interval2distance4xi = int(interval2distance)  
    print("\n (STEP 4A/33) OF SHOOT2ZERO4XI - INTERVAL TO DISTANCE: ", interval2distance4xi)
    # 
    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # MAX PER LAYER WITH MARGINAL
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if max2layer is None:
        max2layer = 100
    max2layer4xi = int(max2layer)
    
    if marginal2layer is None:                              
        marginal2layer = 1.2
    marginal2layer4xi = marginal2layer
        
    omax2layer4xi = max2layer4xi
    
    max2layer4xi = int(marginal2layer4xi * max2layer4xi)
    print("\n (STEP 5A/33) OF SHOOT2ZERO4XI - MAXIMUM SHOTS PER LAYER: ", max2layer4xi, " WITH MARGINAL TO LAYER: ", marginal2layer4xi) 
    # 
                                  
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # MAX SHOTS WITH MARGINAL
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if max2count is None:
        max2count = 100
    max2count4xi = int(max2count) 
         
    if marginal2count is None:    
        marginal2count = 1.2
    marginal2count4xi = marginal2count     
        
    omax2count4xi = max2count4xi
    
    max2count4xi = int(marginal2count4xi * max2count4xi)
            
    print("\n (STEP 6A/33) OF SHOOT2ZERO4XI - MAXIMUM SHOTS: ", max2count4xi, " MARGINAL TO COUNT: ", marginal2count4xi) 
    # 

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # TIME
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                    
    time2start4xi = time4xi()                        
    print("\n (STEP 7A/33) OF SHOOT2ZERO4XI - START TIME: ", time2start4xi)
    # 
                                                                               
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # REQUIRED SIGNS FOR (X,Y,Z)
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if sign2x is None:
        sign2x = '+' 
    sign2x4xi = sign2x
           
    if sign2y is None:
        sign2y = '+'
    sign2y4xi = sign2y    
    if sign2z is None:    
        sign2z = '+'
    sign2z4xi = sign2z
        
    print("\n (STEP 8A/33) OF SHOOT2ZERO4XI - X-SIGN: ", sign2x4xi, 'Y-SIGN: ', sign2y4xi, 'Z-SIGN: ', sign2z4xi)
    #     
         
                              
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # ITERATIONS 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                    
    if max2iterate is None:
        max2iterate = max2count * 21                                # success ratio may be less than 9% 
    max2iterate4xi = max2iterate
    print("\n (STEP 9A/33) OF SHOOT2ZERO4XI - MAXIMUM TO ITERATIONS: ", max2iterate4xi) 
    # 
      
    # =================================================================================================                   
    # AZIMUTH
    # =================================================================================================                
                          
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # azimuth and elevation angle initialized
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # ref: http://en.wikipedia.org/wiki/Radian#Conversion_between_radians_and_degrees
    # one radian is equal to 180/p degrees <=> 1 deg = rad * 180 / pi                             
    # pi/6 = 30, pi/4 = 45, pi/3 = 60, pi/2 = 90, 2/3*pi = 120, 3/4pi=135, 5/6*pi = 150, pi = 180
    # 7/6*pi = 210, 5/4*pi = 225...3*pi/2 = 270, 5*pi/3 = 300 ... 2*pi = 0 or 360 degrees
    # I   = 0...90    (0...pi/2) :     sin+, cos+
    # II  = 90...180  (pi/2...pi):     sin+, cos- 
    # III = 180...270 (pi...3*pi/2):   sin-, cos-
    # IV  = 270...360 (3*pi/2...2*pi): sin-, cos+
    # ref: http://en.wikipedia.org/wiki/Azimuth
                                                            
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
    if start2plusa is None:
        start2plusa = pi/6                      # start plus azimuth 30 degrees - iterates smaller
    start2plusa4xi = start2plusa                                                               
    print("\n (STEP 10A/33) OF SHOOT2ZERO4XI - START TO PLUS AZIMUTH: ", start2plusa4xi) 
    # 
                                     
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
    if max2plusa is None:
        max2plusa = 2*pi                        # extreme plus azimuth 360 degrees around sideways
    max2plusa4xi = max2plusa    
    print("\n (STEP 10B/33) OF SHOOT2ZERO4XI - MAX TO PLUS AZIMUTH: ", max2plusa4xi) 
    # 
                                                         
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
    if min2plusa is None:
        min2plusa = pi/240                      # minum positive azimuth 0.75 degrees sideways 
    min2plusa4xi = min2plusa    
    print("\n (STEP 10C/33) OF SHOOT2ZERO4XI - MIN TO PLUS AZIMUTH: ", min2plusa4xi) 
    #                                  
                              
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
    if start2minusa is None:
        start2minusa = -pi/6                    # start minus azimuth -30 degrees sideways 
    start2minusa4xi = start2minusa
                                                                  
    print("\n (STEP 10D/33) OF SHOOT2ZERO4XI - START TO MINUS AZIMUTH: ", start2minusa4xi) 
    # 
                  
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
    if max2minusa is None:
        max2minusa = -0.98*2*pi                 # extreme minus azimuth almost -360 degrees 
    max2minusa4xi = max2minusa    
    print("\n (STEP 10E/33) OF SHOOT2ZERO4XI - MAX TO MINUS AZIMUTH: ", max2minusa4xi) 
    # 
                                                            
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
    if min2minusa is None:
        min2minusa = -pi/240                    # nearest to zero minus to azimuth
    min2minusa4xi = min2minusa    
    print("\n (STEP 10F/33) MIN TO MINUS AZIMUTH: ", min2minusa4xi) 
    # 

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
    if increase2a is None:
        increase2a = 0.01                       # increase to azimuth
    increase2a4xi = increase2a    
    print("\n (STEP 10G/33) INCREASE2A4XI: ", increase2a4xi)     
    # 
                                                          
    # =================================================================================================                   
    # ELEVATION
    # =================================================================================================                
                                      
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
    if start2pluse is None:
        start2pluse = pi/6                      # start plus elevation 30 degrees up 
    start2pluse4xi = start2pluse    
    print("\n (STEP 11A/33) OF SHOOT2ZERO4XI - START TO PLUS ELEVATION: ", start2pluse4xi) 
    # 
                                          
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
    if max2pluse is None:
        max2pluse = pi                          # most flexible elevation 180 degrees 
    max2pluse4xi = max2pluse    
    print("\n (STEP 11B/33) OF SHOOT2ZERO4XI - MAX TO PLUS ELEVATION: ", max2pluse4xi) 
    # 
                      
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
    if min2pluse is None:
        min2pluse = pi/240                      # lowest plus to elevation 0.75 degrees                          
    min2pluse4xi = min2pluse    
    print("\n (STEP 11C/33) OF SHOOT2ZERO4XI - MIN TO PLUS ELEVATION: ", min2pluse4xi) 
    # 
                                   
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
    if start2minuse is None:
        start2minuse = -pi/6                    # start minus elevation -30 degrees down                                                
    start2minuse4xi = start2minuse    
    print("\n (STEP 11D/33) OF SHOOT2ZERO4XI - START TO MINUS ELEVATION: ", start2minuse4xi) 
    # 
    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                      
    if max2minuse is None:
        max2minuse = -0.98*pi                   # most painful minus elevation almost -180 degrees
    max2minuse4xi = max2minuse    
    print("\n (STEP 11E/33) OF SHOOT2ZERO4XI - MAX TO MINUS ELEVATION: ", max2minuse4xi) 
    # 
                                                
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
    if min2minuse is None:
        min2minuse = -pi/240                    # least painful minus elevation -0.75 degrees
    min2minuse4xi = min2minuse                                  
    print("\n (STEP 11F/33) OF SHOOT2ZERO4XI - MIN TO MINUS ELEVATION: ", min2minuse4xi) 
    # 


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
    if increase2e is None:
        increase2e = 0.01                       # increase to elevation
    increase2e4xi = increase2e    
    print("\n (STEP 11G/33) INCREASE2E4XI: ", increase2e4xi)     
    #     
                                               
    # =================================================================================================      
    # ALGORITHM TUNING 
    # =================================================================================================      
                                         
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # DISTANCE INCREMENTS 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        
    if increase2distance is None:
        increase2distance = 1                   # used to control number of shots per layer
    increase2distance4xi = int(increase2distance)    
    print("\n (STEP 12A/33) OF SHOOT2ZERO4XI - INCREASE TO DISTANCE: ", increase2distance4xi) 
    # 
                                         
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # AZIMUTH CHANGES 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
    if change2a is None: 
        change2a = pi / 60                      # 3 degrees change to azimuth
    change2a4xi = change2a    
    print("\n (STEP 12B/33) OF SHOOT2ZERO4XI - CHANGE TO AZIMUTH: ", change2a4xi) 
    # 
                                        
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # ELEVATION CHANGES 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if change2e is None:
        change2e = pi / 60                      # 3 degrees change to elevation
    change2e4xi = change2e    
    print("\n (STEP 12C/33) OF SHOOT2ZERO4XI - CHANGE TO ELEVATION: ", change2e4xi) 
    # 
                                                                                                                                      
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # AZIMUTH SETTINGS BASED ON SIGN, WHICH MIGHT GET TUNED TO OPPOSITE SIGN LATER ON
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    sign2a4xi = '+'
    if sign2a4xi == '+':
        start2a4xi = start2plusa4xi
        min2a4xi = min2plusa4xi
        max2a4xi = max2plusa4xi
    else:
        start2a4xi = start2minusa4xi
        min2a4xi = min2minusa4xi
        max2a4xi = max2minusa4xi
        
    print("\n (STEP 14/33) OF SHOOT2ZERO4XI - START AZIMUTH: ", start2a4xi, 'MIN AZIMUTH: ', min2a4xi, 'MAX AZIMUTH: ', max2a4xi) 
    # 
                                                                                                                   
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # ELEVATION SETTINGS BASED ON SIGN, WHICH MIGHT GET TUNED TO OPPOSITE SIGN LATER ON
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    sign2e4xi = '+'
    if sign2e4xi == '+':
       start2e4xi = start2pluse4xi
       min2e4xi = min2pluse4xi
       max2e4xi = max2pluse4xi
    else:
       start2e4xi = start2minuse4xi
       min2e4xi = min2minuse4xi
       max2e4xi = max2minuse4xi
            
    print("\n (STEP 15/33) OF SHOOT2ZERO4XI - START ELEVATION: ", start2e4xi, 'MIN ELEVATION: ', min2e4xi, 'MAX ELEVATION: ', max2e4xi) 
    # 
                                                                                                                    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # AZIMUTH START SETTING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                              
    a2shot4xi = start2a4xi 
                                                                                                                    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # ELEVATION START SETTING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                              
    e2shot4xi = start2e4xi                            
                                                                                                              
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # DISTANCE START SETTING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                          
    d2shot4xi = start2distance4xi

    print("\n (STEP 16/33) OF SHOOT2ZERO4XI - START AZIMUTH: ", a2shot4xi, ' START ELEVATION: ', e2shot4xi, ' START DISTANCE: ', d2shot4xi) 
    # 
           
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # initializations for while loop 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    count2shot = 0                                   # shots
    
    count2layer = 1                                  # layers                                                           
    
    count2ok = 0                                     # ok shots with all of (x,y,z) ok 
    
    count2distance = 0                               # measures shot per layer                       
    
    count2iterate = 0                                # hunting for right (x,y,z) combination
    
    count2rejected = 0                               # rejected
    
    ack2x = False                                    # validation for x-coordinate
    nack2x = True
    
    ack2y = False                                    # validation for y-coordinate
    nack2y = True                    
    
    ack2z = False                                    # validation for z-coordinate
    nack2z = True
    
    print("\n (STEP 17A/33) OF SHOOT2ZERO4XI - START TIME OF SHOOTING: ", time4xi(), " FOR ", max2count4xi, " SHOTS")
    # 
    print("\n (STEP 17B/33) OF SHOOT2ZERO4XI - COUNT2OK: ", count2ok, " MAX2COUNT4XI: ", max2count4xi, " COUNT2ITERATE: ", count2iterate, " MAX2ITERATE4XI: ", max2iterate4xi)
    # 
       
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                             
    while ((count2ok <= max2count4xi) and (count2iterate < max2iterate4xi)):   
        # ok shots staying less or equal to that of required amount & iterations not exceeding maximum  
            
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # 
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        count2iterate = count2iterate + 1    
        
        
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # AZIMUTH CHANGES
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        if a2shot4xi >= 0:        
            a2shot4xi = a2shot4xi + change2a4xi
            if a2shot4xi >= max2a4xi:
                start2a4xi = start2a4xi * 1.01
                a2shot4xi = start2a4xi 
                print("\n (STEP 18A/33) OF SHOOT2ZERO4XI - AZIMUTH BECAME BIGGER THAN MAXIMUM: ", max2a4xi , " NEW AZIMUTH: ", a2shot4xi)    
        else:
            a2shot4xi = a2shot4xi - change2a4xi
            if a2shot4xi <= min2a4xi:
                start2a4xi = start2a4xi * 1.01
                a2shot4xi = start2a4xi  
                print("\n (STEP 18B/33) OF SHOOT2ZERO4XI - AZIMUTH BECAME SMALLER THAN MINIMUM: ", min2a4xi , " NEW AZIMUTH: ", a2shot4xi)  
        
        print("\n (STEP 18C/33) OF SHOOT2ZERO4XI - AZIMUTH CHANGES CHECKED ")  
                
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # AZIMUTH ALGORITM CHECKING AGAINST MAXIMUM ALLOWED - RESTART WITH TUNING, IF NECESSARY
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
        if (a2shot4xi >= 2*pi):
            sign2a4xi = '-'                                          # switch to negative
            change2a4xi = 0.98 * change2a4xi                         # change2a always positive
            start2a4xi = change2a4xi * start2minusa4xi               # new minus azimuth start
            a2shot4xi = start2a4xi                                   # new azimuth
            min2a4xi = min2minusa4xi                                 # new minimum to azimuth
            max2a4xi = max2minusa4xi                                 # new maximum to azimuth
            print("\n (STEP 19/33) OF SHOOT2ZERO4XI - AZIMUTH BECAME BIGGER THAN 2*PI , NEW AZIMUTH: ", a2shot4xi) 
             
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # AZIMUTH ALGORITM CHECKING AGAINST MINIMUM ALLOWED- RESTART WITH TUNING, IF NECESSARY
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                             
        if (a2shot4xi <= -2*pi):
            sign2a4xi = '+'                                          # switch to positive
            change2a4xi = 0.98 * change2a4xi                         # change2a always positive
            start2a4xi = change2a4xi * start2plusa4xi                # new positive azimuth start
            a2shot4xi = start2a4xi                                   # new azimuth
            min2a4xi = min2plusa4xi                                  # new minimum to azimuth
            max2a4xi = max2plusa4xi                                  # new maximum to azimuth
            print("\n (STEP 20A/33) OF SHOOT2ZERO4XI - AZIMUTH BECAME LESS THAN -2*PI, NEW AZIMUTH: ", a2shot4xi) 
        
        print("\n (STEP 20B/33) OF SHOOT2ZERO4XI - AZIMUTH MAX AND MINIMUM CHANGES CHECKED ")       
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # ELEVATION CHANGES
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        if e2shot4xi <= 0:
            e2shot4xi = e2shot4xi - increase2e4xi
            if e2shot4xi <= min2e4xi:
                change2e4xi = 1.02 * change2e4xi
                start2e4xi = change2e4xi * start2e4xi
                e2shot4xi = start2e4xi
                print("\n (STEP 21/33) OF SHOOT2ZERO4XI - ELEVATION BECAME LESS THAN MINIMUM: ", min2e4xi, " NEW ELEVATION: ", e2shot4xi)                                   
        else:
            e2shot4xi = e2shot4xi + increase2e4xi
            if e2shot4xi >= max2e4xi:
                change2e4xi = 1.08 * change2e4xi
                start2e4xi = change2e4xi * start2e4xi
                e2shot4xi = start2e4xi
                print("\n (STEP 22A/33) OF SHOOT2ZERO4XI - ELEVATION BECAME BIGGER THAN MAXIMUM: ", max2e4xi, " NEW ELEVATION: ", e2shot4xi)  
        
        print("\n (STEP 22B/33) OF SHOOT2ZERO4XI - ELEVATION CHANGES CHECKED ")                                                        
        
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # ELEVATION ALGORITM CHECKING AGAINST MAXIMUM ALLOWED - RESTART WITH TUNING, IF NECESSARY
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                                                   
        if (e2shot4xi >= pi):
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            # start again with a new elevation and new elevation change
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            sign2e4xi = '-'                                             # switch to negative
            change2e4xi = 0.98 * change2e4xi                            # change2e always positive
            start2e4xi = change2e4xi * start2minuse4xi                  # new minus elevation start
            e2shot4xi = start2e4xi                                      # new azimuth
            min2e4xi = min2minuse4xi                                    # new minimum to elevation
            max2e4xi = max2minuse4xi                                    # new maximum to elevation
            print("\n (STEP 23A/33) OF SHOOT2ZERO4XI - ELEVATION BECAME BIGGER THAN PI, NEW ELEVATION: ", e2shot4xi)
            
        print("\n (STEP 23B/33) OF SHOOT2ZERO4XI - ELEVATION MAX CHANGE CHECKED ") 
                        
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # ELEVATION ALGORITM CHECKING AGAINST MINIMUM ALLOWED- RESTART WITH TUNING, IF NECESSARY
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
        
        if (e2shot4xi <= -pi):
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            # start again with a new elevation and new elevation change
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                            
            sign2e4xi = '+'                                             # switch to positive
            change2e4xi = 0.98 * change2e4xi                            # change2e always positive
            start2e4xi = change2e4xi * start2pluse4xi                   # new positive elevation start
            e2shot4xi = start2e4xi                                      # new azimuth
            min2e4xi = min2pluse4xi                                     # new minimum to elevation
            max2e4xi = max2pluse4xi                                     # new maximum to elevation        
            print("\n (STEP 24A/33) OF SHOOT2ZERO4XI - ELEVATION BECAME LESS THAN -PI, NEW ELEVATION: ", e2shot4xi)
            
        print("\n (STEP 24B/33) OF SHOOT2ZERO4XI - ELEVATION MIN CHANGE CHECKED ")         
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # SHOOT
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        print("\n (STEP 25A/33) OF SHOOT2ZERO4XI - SETTING WITH SET_SPHERE2ZERO4XI")  
        print("\n A2SHOT4XI OF SHOOT2ZERO4XI: ", a2shot4xi)                       # 0.575958653158
        print("\n E2SHOT4XI OF SHOOT2ZERO4XI: ", e2shot4xi)                       # 0.533598775598  
        print("\n D2SHOT4XI OF SHOOT2ZERO4XI: ", d2shot4xi)                       # 100  
        print("\n INTERVAL2DISTANCE4XI OF SHOOT2ZERO4XI: ", interval2distance4xi) # 100
                                                                                 
        shot2xi = set_sphere2zero4xi(azimuth2shot = a2shot4xi, elevation2shot = e2shot4xi, distance2shot = d2shot4xi, area2shot = int(4*pi*d2shot4xi**2/interval2distance4xi))
        
        print("\n (STEP 25B/33) OF SHOOT2ZERO4XI - PERFORMED SET_SPHERE2ZERO4XI, SPHERE4XI: ", shot2xi)  
        # 
            
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # CHECK THE SHOT 
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        print("\n (STEP 25C/33) OF SHOOT2ZERO4XI - GETTING")  
        shot2examine = get_sphere2zero4xi(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes', area2shot = 'Yes')
        
        print("\n (STEP 25D/33) OF SHOOT2ZERO4XI - PERFORMED GET")  
        # 
        
        print("\n (STEP 25E/33) OF SHOOT2ZERO4XI - SHOT TO EXAMINE ", count2shot, ": ", shot2examine)  
        # 
         
        keys2examine = shot2examine.keys()
        print("\n (STEP 26A/33) OF SHOOT2ZERO4XI - KEYS2EXAMINE: ", keys2examine)   
        # 
        
        for key2examine in sorted(keys2examine):
            print("\n (STEP 26B/33) OF SHOOT2ZERO4XI - KEY2EXAMINE ", key2examine)  
            # 
            
            ack2x = False 
            nack2x = True                                  
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            # X OK ?
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
            try:
                index2x=str.find(key2examine,'x')                               
                x2coordinate = int(key2examine[0:index2x])
                if x2coordinate >= 0:
                    if sign2x4xi == '+':
                        ack2x = True
                        nack2x = False
                        print("\n (STEP 27A/33) OF SHOOT2ZERO4XI - X2COORDINATE ACK: ", ack2x) 
                else:
                    if sign2x4xi == '-':
                        ack2x = True
                        nack2x = False
                        print("\n (STEP 27B/33) OF SHOOT2ZERO4XI - X2COORDINATE ACK: ", ack2x)
                         
            except:
                print("\n (STEP 27C/33) : *** FAILED WITH KEY2EXAMINE: ", key2examine)
                print("\n (STEP 27D/33) OF SHOOT4XI -INDEX2X: ", index2x)
                
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            # Y OK ?
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
            ack2y = False 
            nack2y = True     
            try:
                index2y=str.find(key2examine,'y')                               
                y2coordinate = int(key2examine[index2x+1:index2y])
                if y2coordinate >= 0:
                    if sign2y4xi == '+':
                        ack2y = True
                        nack2y = False
                        print("\n (STEP 27E/33) OF SHOOT2ZERO4XI - Y2COORDINATE ACK: ", ack2y)                                         
                else:
                    if sign2y4xi == '-':
                        ack2y = True
                        nack2y = False
                        print("\n (STEP 27F/33) OF SHOOT2ZERO4XI - Y2COORDINATE ACK: ", ack2y)                               
            except:
                print("\n (STEP 27G/33) OF SHOOT2ZERO4XI - *** FAILED WITH KEY2EXAMINE: ", key2examine)
                print("\n (STEP 27H/33) OF SHOOT2ZERO4XI - INDEX2Y: ", index2y)
                
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            # Z OK ?
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
            ack2z = False 
            nack2z = True                                 
            try:
                index2z=str.find(key2examine,'z')                               
                z2coordinate = int(key2examine[index2y+1:index2z])
                if z2coordinate >= 0:
                    if sign2z4xi == '+':
                        ack2z = True
                        nack2z = False
                        print("\n (STEP 27I/33) OF SHOOT2ZERO4XI - Z2COORDINATE ACK: ", ack2z)                                               
                else:
                    if sign2z4xi == '-':
                        ack2z = True
                        nack2z = False
                        print("\n (STEP 27J/33) OF SHOOT2ZERO4XI - Z2COORDINATE ACK: ", ack2z)                                  
            except:
                print("\n (STEP 27K/33) OF SHOOT2ZERO4XI - *** FAILED WITH KEY2EXAMINE: ", key2examine)
                print("\n (STEP 27L/33) OF SHOOT2ZERO4XI - INDEX2Z: ", index2z)
                
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            # (X,Y,Z) OK ?
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
            try:                                                           
                if ((ack2x is True) and (ack2y is True) and (ack2z is True)):
                    print("\n (STEP 27M1/33) OF SHOOT2ZERO4XI - OK: (" , x2coordinate, ",", y2coordinate, ",", z2coordinate, ")") 
                    # 
                    print("\n (STEP 27M2/33) OF SHOOT2ZERO4XI - EXPECTED: (" , sign2x4xi, ",", sign2y4xi, ",", sign2z4xi, ")") 
                    # 
                    count2ok = count2ok + 1 
                    print("\n (STEP 27M3/33) OF SHOOT2ZERO4XI - COUNT2OK: " , count2ok, " MAX2LAYER4Xi: ", max2layer4xi) 
                    
                    count2distance = count2distance + increase2distance4xi      # one more shot for this layer and distance
                    print("\n (STEP 27M4/33) OF SHOOT2ZERO4XI - COUNT2DISTANCE: " , count2distance, " MAX2LAYER4Xi: ", max2layer4xi)
                    # 
                    
                    if count2distance >= max2layer4xi:
                        d2shot4xi = d2shot4xi + interval2distance4xi            # distance for the next layer
                        count2distance = 0
                        count2layer = count2layer + 1 
                        print("\n (STEP 27M5/33) OF SHOOT2ZERO4XI - NEW LAYER NUMBER: ", count2layer, ' NEW DISTANCE: ', d2shot4xi) 
                        # 
                    else:
                        pass 

                else:
                    print("\n (STEP 27P/33) OF SHOOT2ZERO4XI - REJECTED: (" , x2coordinate, ",", y2coordinate, ",", z2coordinate, ")")
                    print("\n (STEP 27Q/33) OF SHOOT2ZERO4XI - EXPECTED: (" , sign2x4xi, ",", sign2y4xi, ",", sign2z4xi, ")")
                    
                    count2rejected = count2rejected + 1
                    # 
                    # 
                    
                    
                    
                                        
            except:
                print("\n (STEP 27S/33) OF SHOOT2ZERO4XI - *** FAILED WITH KEY2EXAMINE: ", key2examine)
                print("\n (STEP 27T/33) OF SHOOT2ZERO4XI - INDEX2Z: ", index2z)
        
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # CONTINUE WHILE
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                    
        print("\n (STEP 28A/33) OF SHOOT2ZERO4XI - CONTINUING WHILE WITH:")
        print("\n COUNT2OK OF SHOOT2ZERO4XI: ", count2ok)
        print("\n COUNT2DISTANCE OF SHOOT2ZERO4XI: ", count2distance)   
        print("\n MAX2COUNT OF SHOOT2ZERO4XI: ", max2count4xi)                        
        print("\n COUNT2ITERATE OF SHOOT2ZERO4XI: ", count2iterate)
        print("\n MAX2ITERATE OF SHOOT2ZERO4XI: ", max2iterate4xi)                        

        
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # END OF WHILE
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
             
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # EXAMINE RESULTS AFTER WHILE
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    time2end = time4xi()           
    print("\n (STEP 30A1/33) OF SHOOT2ZERO4XI - STATISTICS FOR SHOOTING, WHICH ENDED: ", time2end)                           
    print("\n SHOTS OK OF SHOOT2ZERO4XI: ", count2ok, " = ", int(100 * count2ok/max2count4xi), " %")                              
    print("\n SHOTS ORIGINALLY REQUIRED OF SHOOT2ZERO4XI: ", omax2count4xi)      
    print("\n ITERATIONS NEEDED OF SHOOT2ZERO4XI: ", count2iterate)                              
    print("\n ITERATIONS ALLOWED OF SHOOT2ZERO4XI: ", max2iterate4xi) 
    print("\n REJECTED OF SHOOT2ZERO4XI: ", count2rejected, " = ", int(100 * count2rejected/count2iterate), " %") 

    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # SHOW RESULTS
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
           
    print("\n (STEP 30B1/33) OF SHOOT2ZERO4XI - WHOLE BALL AFTER ALL OPERATIONS AND WITH MAX2COUNT: ", max2count4xi, 'TIME PRINTED: ', time4xi())  
    
    sphere2return = {}                                                 # only ok shots returned
     
    sphere2show = get_sphere2zero4xi()
    dict2keys = sphere2show.keys()
    # 
     
    print("\n (STEP 30B3/33) OF SHOOT2ZERO4XI - SHOOTING SAMPLE OF : ", max2count4xi, " SHOTS", "NUMBER OF LAYERS: ", count2layer, ' LATEST DISTANCE: ', d2shot4xi, ' INTERVAL2DISTANCE: ', interval2distance4xi)    
    # 

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
    count2plusx = 0
    count2plusy = 0
    count2plusz = 0
           
    count2minusx = 0
    count2minusy = 0
    count2minusz = 0
    
    count2accepted = 0
    count2rejected = 0
    
    order2key = 1
    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # ANALYZE SUCCEEDED SHOTS
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
             
    for key2dict in sorted(dict2keys):
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # 
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            
        try:
            index2x=str.find(key2dict,'x')                               
            x2coordinate = int(key2dict[0:index2x])
            # print("\n (STEP 31/33) X2COORDINATE: ",  x2coordinate)
            if x2coordinate >= 0:
                count2plusx = count2plusx + 1
            else:
                count2minusx = count2minusx + 1    
        except:
            print("\n (STEP 31A/33) OF SHOOT2ZERO4XI - *** FAILED WITH KEY2DICT: ", key2dict)
            print("\n (STEP 31B/33) OF SHOOT2ZERO4XI - INDEX2X: ", index2x)
            
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # 
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                 
        try:                                   
            index2y=str.find(key2dict,'y')
            y2coordinate = int(key2dict[index2x+1:index2y])
            # print("\n (STEP 31/33) Y2COORDINATE: ",  y2coordinate)
            if y2coordinate >= 0:
                count2plusy = count2plusy + 1
            else:
                count2minusy = count2minusy + 1  
        except:
            print("\n (STEP 31C/33) OF SHOOT2ZERO4XI - : *** FAILED WITH KEY2DICT: ", key2dict) 
            print("\n (STEP 31D/33) OF SHOOT2ZERO4XI - INDEX2X: ", index2x)
            print("\n (STEP 31E/33) OF SHOOT2ZERO4XI - INDEX2Y: ", index2y)
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # 
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
             
        try:                                                                         
            index2z=str.find(key2dict,'z') 
            z2coordinate = int(key2dict[index2y+1:index2z])
            # print("\n (STEP 31/33) Z2COORDINATE: ",  z2coordinate)
            if z2coordinate >= 0:
                count2plusz = count2plusz + 1
            else:
                count2minusz = count2minusz + 1
        except:
            print("\n (STEP 31F/33) OF SHOOT2ZERO4XI - *** FAILED WITH KEY2DICT: ", key2dict)
            print("\n (STEP 31G/33) OF SHOOT2ZERO4XI - INDEX2X: ", index2x)
            print("\n (STEP 31H/33) OF SHOOT2ZERO4XI - INDEX2Y: ", index2y)
            print("\n (STEP 31I/33) OF SHOOT2ZERO4XI - INDEX2Z: ", index2z)
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # 
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
             
        ack2x = False    
        if ((x2coordinate >= 0) and (sign2x4xi == '+')):
            ack2x = True
        if ((x2coordinate <= 0) and (sign2x4xi == '-')):
            ack2x = True                        
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # 
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
             
        ack2y = False    
        if ((y2coordinate >= 0) and (sign2y4xi == '+')):
            ack2y = True
        if ((y2coordinate <= 0) and (sign2y4xi == '-')):
            ack2y = True     
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # 
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
             
        ack2z = False    
        if ((z2coordinate >= 0) and (sign2z4xi == '+')):
            ack2z = True
        if ((z2coordinate <= 0) and (sign2z4xi == '-')):
            ack2z = True     
        
        if ((ack2x is True) and (ack2y is True) and (ack2z is True)                                 # (x,y,z) combination ok
            and((fabs(x2coordinate) > 1) or (fabs(y2coordinate) > 1) or (fabs(z2coordinate) > 1))): # core and skeleton coordinates omitted
            count2accepted = count2accepted + 1                                                                                                      
            print("\n (STEP 31/33) OF SHOOT2ZERO4XI - ACCEPTANCE: ", count2accepted, " SHOT: ", order2key, ":", key2dict, " EXPECTED SIGNS: (" , sign2x4xi, ",", sign2y4xi, ",", sign2z4xi, ")") 
            # 
            
            sphere2return[key2dict] = sphere2show[key2dict]
            
        else:
            count2rejected = count2rejected + 1
            # 
                                        
        order2key = order2key +1 
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # end of for loop
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
          

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # STATISTICS
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                  
    count2tried = count2accepted + count2rejected 
    
    sum2plus = count2plusz + count2plusy+ count2plusz
    sum2minus = count2minusx + count2minusy+ count2minusz
    sum2total = count2plusx + count2minusx # same also with y and z - coordinate exists only once
            
    print('=' *80)
    print("\n (STEP 32/33) OF SHOOT2ZERO4XI - STATISTICS FOR REQUIRED: ", max2count4xi, " SHOTS")       
    print("\n START TIME: ", time2start)
    print("\n ACCEPTED: ", count2accepted, " = ", int(100*count2accepted/order2key), " %")
    print("\n REJECTED: ", count2rejected, " = ", int(100*count2rejected/order2key), " %")
   
    print("\n DISTIBUTION OF X, Y AND Z: ") 
    print("\n +X: ", count2plusx, " = ", int(100*count2plusx/sum2total), " %")
    print("\n -X: ", count2minusx, " = ", int(100*count2minusx/sum2total), " %") 
   
    print("\n +Y: ", count2plusy, " = ", int(100*count2plusy/sum2total), " %")
    print("\n -Y: ", count2minusy, " = ", int(100*count2minusy/sum2total), " %") 
   
    print("\n +Z: ", count2plusz, " = ", int(100*count2plusz/sum2total), " %")
    print("\n -Z: ", count2minusz, " = ", int(100*count2minusz/sum2total), " %") 
              
    
    print("\n SUM2TOTAL: ", sum2total, "SUCCESS-RATIO: ", int(100*count2accepted/max2count4xi), " %", " COUNT2LAYER: ", count2layer)
    print("\n START2DISTANCE: ", start2distance4xi, " INTERVAL2DISTANCE: ", interval2distance4xi, " MAX2LAYER: ", max2layer4xi, " MAX2COUNT : ", max2count4xi)
    print("\n EXPECTED COORDINATE SIGNS: (X"  , sign2x4xi, ",Y", sign2y4xi, ",Z", sign2z4xi, ")") 
    
    print("\n REASONING: ")
    if count2accepted >= omax2count4xi:
        print("\n OK SHOOTING: ACCEPTED SHOTS ", count2accepted, " >= ", omax2count4xi, " ORIGINALLY REQUIRED, MARIGINAL: ", marginal2count4xi)
    else:
        print("\n *** FAILED SHOOTING: ACCEPTED SHOT ONLY: ", count2accepted, " < ", omax2count4xi, " REQUIRED !")                                    
    
    print("\n END TIME OF SHOOT4XI: ", time2end)
    print('=' *80)
    # ================================================================================
    #  (STEP 32/33) OF SHOOT2ZERO4XI - STATISTICS FOR REQUIRED:  96  SHOTS
    #  START TIME:  00:25:49 06/28/10 Pacific Daylight Time
    #  ACCEPTED:  95  =  29  %
    #  REJECTED:  229  =  70  %
    #  DISTIBUTION OF X, Y AND Z: 
    #  +X:  172  =  53  %
    #  -X:  152  =  46  %
    #  +Y:  7  =  2  %
    #  -Y:  317  =  97  %
    #  +Z:  146  =  45  %
    #  -Z:  178  =  54  %
    #  SUM2TOTAL:  324 SUCCESS-RATIO:  98  %  COUNT2LAYER:  9
    #  START2DISTANCE:  10  INTERVAL2DISTANCE:  10  MAX2LAYER:  12  MAX2COUNT :  96
    #  EXPECTED COORDINATE SIGNS: (X - ,Y - ,Z - )
    #  REASONING: 
    #  OK SHOOTING: ACCEPTED SHOTS  95  >=  80  ORIGINALLY REQUIRED, MARIGINAL:  1.2
    #  END TIME OF SHOOT4XI:  00:25:51 06/28/10 Pacific Daylight Time
    # ================================================================================   
 
        
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # RETURN
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if queue2zero is None:
        
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # DICTIONARY RETURNING
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
          
        print("\n (STEP 33A/33) OF SHOOT2ZERO4XI - RETURNING COORDINATE DICTIONARY AS VARIABLE")   
        return sphere2return
    else:

        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # QUEUE RETURNING
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        ack2put = False
        queue2zero4xi = queue2zero
        
        print("\n (STEP 33B/33) OF SHOOT2ZERO4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2ZERO4XI: ", queue2zero4xi, " - TIME: ", time4xi())  
        try:
            # -------------------------------------------------------------------------------------
            # PUT DICTIONARY TO QUEUE 
            # -------------------------------------------------------------------------------------                 
            queue2zero4xi.put(sphere2return)
            print("\n (STEP 33C/33) OF SHOOT2ZERO4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2ZERO4XI: ", queue2zero4xi, " - TIME: ", time4xi()) 
            # 
            ack2put = True
        except:
            print("\n (STEP 33D/33) OF SHOOT2ZERO4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2ZERO4XI: ", queue2zero4xi, " - TIME: ", time4xi()) 
        
        print("\n (STEP 33E1/33E) OF SHOOT2ZERO4XI - TRYING TO WRITE DICTIONARY TO FILE - TIME: ", time4xi()) 
        try:                
            # ---------------------------------------------------------------------------------------------
            # WRITE SHOT TO FILE 
            # ---------------------------------------------------------------------------------------------
            path2file      = '..\\..\\txt\\shot2zero4xi.txt'
            text2copyright = '<!-- Copyright Small & Smart - California, United States of America - All rights reserved. -->' + '\n'
       
            
            f2xi=open(path2file, 'w')
            print("\n (STEP 33E2/33E) OF SHOOT2ZERO4XI - OPENED FILE: ", path2file, " - TIME: ", time4xi())   
            # 
            
                                
            # ---------------------------------------------------------------------------------------------
            # START
            # ---------------------------------------------------------------------------------------------                 
            f2xi.write(text2copyright)
              
            # ---------------------------------------------------------------------------------------------
            # BODY
            # ---------------------------------------------------------------------------------------------                 
            keys2write = sorted(sphere2return.keys())

            for key2write in sorted(keys2write):
                line2write = str(key2write) + '\n'
                f2xi.write(line2write)            
                
                line2write = str(sphere2return[key2write]) + '\n'
                f2xi.write(line2write) 
                                
            # ---------------------------------------------------------------------------------------------
            # END
            # ---------------------------------------------------------------------------------------------                 
            f2xi.write(text2copyright)
                
            print("\n (STEP 33F/33) OF SHOOT2ZERO4XI -  WROTE SHOT2ZERO4XI - TIME: ", time4xi()) 

            # 

            
            # ---------------------------------------------------------------------------------------------
            # 
            # ---------------------------------------------------------------------------------------------                 
            f2xi.close()     
            print("\n (STEP 33G/33) OF SHOOT2ZERO4XI -  CLOSED SHOT2ZERO4XI - TIME: ", time4xi()) 
            # 
             
        except:
            print("\n (STEP 33X/33) OF SHOOT2ZERO4XI *** FAILED TO WRITE SHOT2ZERO4XI - TIME: ", time4xi())
        
                    
        print("\n (STEP 33E/33) OF SHOOT2ZERO4XI - TRYING TO SEND INFORMATION OF PUT-OPERATION VIA PUBLISHER_CHANNEL2ZERO: ", publisher_channel2zero, " - TIME: ", time4xi())      
        try:                
            # ---------------------------------------------------------------------------------------------
            # INFORM PUT OPERATION VIA PIPE'S PUBLISHER CHANNEL 
            # ---------------------------------------------------------------------------------------------
            if ack2put is True:
                message2send4eight = "<ack2put4xi>queue2zero</ack2put4xi>"
            else:
                message2send4eight = "<nack2put4xi>queue2zero</nack2put4xi>" 
 
            publisher_channel2zero.send(message2send4eight)
            print(" (STEP 33G/33) OF SHOOT2ZERO4XI -  SENT MESSAGE2SEND4ZERO: ", message2send4eight, " TO PUBLISHER_CHANNEL2ZERO: ", publisher_channel2zero, " - TIME: ", time4xi()) 
            # 
 
        except:
            print(" (STEP 33H/33) OF SHOOT2ZERO4XI *** FAILED TO SEND MESSAGE2SEND4ZERO: ", message2send4eight, " TO PUBLISHER_CHANNEL2ZERO: ", publisher_channel2zero, " - TIME: ", time4xi()) 

        print("\n (STEP 33I/33) OF SHOOT2ZERO4XI - RETURNING QUEUE OBJECT QUEUE2ZERO4XI: ", queue2zero4xi, " - TIME: ", time4xi())  
         
        return queue2zero4xi    

#</function4xi>
    
    
#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_sphere4xi.txt
#   sense-test-sphere4xi.xml
#   reason-test-sphere4xi.xml
#   ace-test-sphere4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of shoot2zero4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
